program Listing2;

uses
  RTTI, System.SysUtils, TypInfo, System.Classes;

type
  TNajprostszyInterfejsWirtualny = class(TVirtualInterface)
    constructor Create(PIID: PTypeInfo);
    procedure WywołajMetodę(Metoda: TRttiMethod; const Argumenty: TArray<TValue>;
      out Wynik: TValue);
  end;

constructor TNajprostszyInterfejsWirtualny.Create(PIID: PTypeInfo);
begin
  inherited Create(PIID, WywołajMetodę);
end;

procedure TNajprostszyInterfejsWirtualny.WywołajMetodę(Metoda: TRttiMethod;
          const Argumenty: TArray<TValue>; out Wynik: TValue);
begin
  WriteLn('Wywołałeś metodę interfejsu');
end;

type
  IStartStop = interface(IInvokable)
    ['{3B2171B0-D1C3-4A8C-B09E-ACAC4D625E57}']
    procedure Start;
    procedure Stop(aLiczba: integer);
  end;

var
  StartStop: IStartStop;
begin
  StartStop := TNajprostszyInterfejsWirtualny.Create(TypeInfo(IStartStop)) as IStartStop;
  StartStop.Start;
  StartStop.Stop(42);
  ReadLn;
end.